<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('users', function (Blueprint $table) {
            $table->id();
            $table->string('name');
            $table->string('email')->unique();
            $table->timestamp('email_verified_at')->nullable();
            $table->string('password');
            $table->string('device_id')->nullable();
            $table->enum('role', ['admin', 'user'])->default('user');
            $table->enum('jabatan', [
                'Kepala Desa',
                'Sekretaris',
                'Kasi 1',
                'Kasi 2',
                'Kasi 3',
                'Kaur 1',
                'Kaur 2',
                'Kadus 1',
                'Staf',
            ])->default('Staf');
            $table->string('otp')->nullable();
            $table->timestamp('otp_expires_at')->nullable();

            $table->string('phone', 255)->nullable();
            $table->string('employee_id')->nullable();
            $table->enum('status', ['aktif', 'tidak aktif'])->default('aktif');
            $table->text('address')->nullable();
            $table->date('hire_date')->nullable();

            $table->string('nik', 16)->unique();
            $table->string('tempat_lahir', 255);
            $table->date('tanggal_lahir');
            $table->string('alamat', 500)->nullable();
            $table->string('no_telepon', 13)->nullable();
            $table->enum('jenis_kelamin', ['Laki-laki', 'Perempuan']);
            $table->string('url_photo', 1000)->nullable();

            $table->rememberToken();
            $table->timestamps();
        });

        Schema::create('password_reset_tokens', function (Blueprint $table) {
            $table->string('email')->primary();
            $table->string('token');
            $table->timestamp('created_at')->nullable();
        });

        Schema::create('sessions', function (Blueprint $table) {
            $table->string('id')->primary();
            $table->foreignId('user_id')->nullable()->index();
            $table->string('ip_address', 45)->nullable();
            $table->text('user_agent')->nullable();
            $table->longText('payload');
            $table->integer('last_activity')->index();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('users');
        Schema::dropIfExists('password_reset_tokens');
        Schema::dropIfExists('sessions');
    }
};
